import { Algodv2, Indexer } from "algosdk";
import { PactLendingPool, PactLendingPoolInfo, PoolManagerInfo, TinymanLendingPool, TinymanLendingPoolInfo } from "./types";
/**
 *
 * Returns information regarding the given Pact lending pool.
 *
 * @param client - Algorand client to query
 * @param lendingPool - Pact lending pool to query about
 * @param poolManagerInfo - pool manager info which is returned by retrievePoolManagerInfo function
 * @returns Promise<LendingPoolInfo> lending pool info
 */
declare function retrievePactLendingPoolInfo(client: Algodv2 | Indexer, lendingPool: PactLendingPool, poolManagerInfo: PoolManagerInfo): Promise<PactLendingPoolInfo>;
/**
 *
 * Returns information regarding the given Tinyman lending pool.
 *
 * @param client - Algorand client to query
 * @param tinymanAppId - Tinyman application id where lending pool belongs to
 * @param lendingPool - Pact lending pool to query about
 * @param poolManagerInfo - pool manager info which is returned by retrievePoolManagerInfo function
 * @returns Promise<LendingPoolInfo> lending pool info
 */
declare function retrieveTinymanLendingPoolInfo(client: Algodv2 | Indexer, tinymanAppId: number, lendingPool: TinymanLendingPool, poolManagerInfo: PoolManagerInfo): Promise<TinymanLendingPoolInfo>;
export { retrievePactLendingPoolInfo, retrieveTinymanLendingPoolInfo };
//# sourceMappingURL=amm.d.ts.map