import { SuggestedParams, Transaction } from "algosdk";
import { OpUp } from "./types";
/**
 *
 * Given a transaction or transaction group, prefixes it with appl call to increase opcode budget and returns the new
 * transaction group.
 * A lot of the lending operations require additional opcode cost so use this to increase the budget.
 *
 * @param opup - opup applications
 * @param userAddr - account address for the user
 * @param transactions - transaction(s) to prefix opup to
 * @param numInnerTransactions - number of inner transactions to issue (remaining opcode is 691 + 689 * num.inner.txns)
 * @param params - suggested params for the transactions with the fees overwritten
 * @returns Transaction[] transaction group with opup prefixed
 */
declare function prefixWithOpUp(opup: OpUp, userAddr: string, transactions: Transaction | Transaction[], numInnerTransactions: number, params: SuggestedParams): Transaction[];
export { prefixWithOpUp };
//# sourceMappingURL=opup.d.ts.map