"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertXAlgoToAlgo = exports.convertAlgoToXAlgoWhenDelay = exports.convertAlgoToXAlgoWhenImmediate = void 0;
const mathLib_1 = require("../mathLib");
function convertAlgoToXAlgoWhenImmediate(algoAmount, consensusState) {
    const { algoBalance, xAlgoCirculatingSupply, premium } = consensusState;
    return (0, mathLib_1.mulScale)((0, mathLib_1.mulScale)(algoAmount, xAlgoCirculatingSupply, algoBalance), mathLib_1.ONE_16_DP - premium, mathLib_1.ONE_16_DP);
}
exports.convertAlgoToXAlgoWhenImmediate = convertAlgoToXAlgoWhenImmediate;
function convertAlgoToXAlgoWhenDelay(algoAmount, consensusState) {
    const { algoBalance, xAlgoCirculatingSupply } = consensusState;
    return (0, mathLib_1.mulScale)(algoAmount, xAlgoCirculatingSupply, algoBalance);
}
exports.convertAlgoToXAlgoWhenDelay = convertAlgoToXAlgoWhenDelay;
function convertXAlgoToAlgo(xAlgoAmount, consensusState) {
    const { algoBalance, xAlgoCirculatingSupply } = consensusState;
    return (0, mathLib_1.mulScale)(xAlgoAmount, algoBalance, xAlgoCirculatingSupply);
}
exports.convertXAlgoToAlgo = convertXAlgoToAlgo;
//# sourceMappingURL=formulae.js.map